use crate::config::parameter::AppConfig;

mod config;

fn main() {
    let config = AppConfig::new()
        .map_err(|e| {
            eprintln!("Configuration error: {}", e);
            std::process::exit(1);
        })
        .and_then(|cfg| {
            cfg.validate().map_err(|errors| {
                eprintln!(
                    "Configuration validation errors:\n\t{}",
                    errors.join("\n\t")
                );
                std::process::exit(1);
            })?;
            Ok(cfg)
        })
        .unwrap();

    println!("Hello, world! {}", config.service_version);
}
